<template>
  <div>
    <v-btn class="d-none d-md-inline-flex" nuxt color="accent" @click.stop="actionBtn">
      <span class="subtitle-1 font-weight-light text-capitalize">
        {{ isLoggedIn ? 'Logout' : 'Sign In' }}
      </span>
    </v-btn>
    <v-dialog
      v-model="dialog"
      :overlay-opacity="0.5"
      :fullscreen="asFullScreen"
      content-class="width-auto"
      overlay-color="grey lighten-2"
    >
      <v-card class="d-flex flex-row py-4 px-5" style="width: 40vw; max-width: 600px; min-width: 400px" :loading="isLoading ? 'accent' : false">
        <v-btn icon absolute right @click="dialog = false">
          <v-icon>{{ mdiClose }}</v-icon>
        </v-btn>
        <v-row class="fill-height ma-0" align="stretch">
          <v-col cols="6" class="white--text d-none" tile style="background: var(--v-accent-base)">
            Empty
          </v-col>
          <v-col cols="12" md="12" class="d-flex flex-column">
            <v-img
              :src="require('@/assets/img/brand-logo.svg')"
              contain
              class="justify-self-start"
              style="pointer-events: none;"
              max-height="60px"
            />
            <v-form
              ref="formRef"
              :key="isSigningIn ? 'signin' : 'register'"
              v-model="isValid"
              autocomplete="on"
              class="d-flex flex-column"
            >
              <v-text-field
                v-if="!isSigningIn"
                v-model="form.name"
                :disabled="isLoading"
                dense
                autocomplete="name"
                :rules="[v => !!v || 'Name is required']"
                class="no-border shrink mt-5"
                label="Name"
                outlined
              />
              <v-text-field
                v-model="form.email"
                :disabled="isLoading"
                dense
                :rules="emailRules"
                autocomplete="email"
                class="no-border shrink"
                :error-messages="emailErrors"
                label="Email"
                outlined
              />
              <v-text-field
                v-model="form.password"
                :disabled="isLoading"
                dense
                :autocomplete="isSigningIn ? 'current-password' : 'new-password'"
                :rules="[v => !!v || 'Password is required']"
                type="password"
                class="no-border shrink"
                :error-messages="passwordErrors"
                :label="(isSigningIn ? '' : 'New ') + 'Password'"
                outlined
              />
              <v-btn
                color="accent"
                depressed
                tile
                :loading="isLoading"
                @click="isSigningIn ? login() : register()"
              >
                {{ isSigningIn ? 'Sign In' : 'Register' }}
              </v-btn>
              <span class="caption font-weight-light black--text text-center my-2">
                {{ isSigningIn ? "Don't have an account yet?" : "Already have an account?" }}
                <a class="accent--text" @click="isSigningIn = !isSigningIn">
                  {{ isSigningIn ? 'Sign Up' : 'Sign In' }}
                </a>
              </span>
            </v-form>
            <div class="d-flex align-center">
              <v-divider style="width: 100px" />
              <span class="mx-4 caption font-weight-light">Or</span>
              <v-divider style="width: 100px" />
            </div>
            <v-row class="py-3" dense justify="space-between" style="width: 100%">
              <v-col v-for="social in socials" :key="social.name" cols="6">
                <v-btn
                  color="accent lighten-1"
                  dark
                  depressed
                  block
                  tile
                  @click="openPopUp(social.name)"
                >
                  <v-icon left :size="social.iconSize">
                    {{ social.icon }}
                  </v-icon>
                  <span class="text-capitalize">
                    {{ social.name }}
                  </span>
                </v-btn>
              </v-col>
            </v-row>
          </v-col>
        </v-row>
      </v-card>
    </v-dialog>
  </div>
</template>

<script lang="ts">
import { mdiFacebook, mdiGoogle, mdiClose } from '@mdi/js'
import colors from 'vuetify/lib/util/colors'
import { defineComponent, ref, computed, reactive, watch, onMounted } from '@vue/composition-api'

export default defineComponent({
  name: 'AppBarSignIn',
  setup (_, { root }) {
    const formRef = ref<HTMLFormElement>(null)
    const dialog = ref(false)
    const isValid = ref(false)
    const isSigningIn = ref(true)
    const isLoading = computed(() => root.$store.getters['auth/isLoading'])
    const isLoggedIn = computed(() => root.$store.getters['auth/isLoggedIn'])
    const emailErrors = ref('')
    const passwordErrors = ref('')
    const form = reactive({
      name: undefined,
      email: undefined,
      password: undefined
    })

    onMounted(() => {
      window.addEventListener('message', (event) => {
        if (event.origin !== 'https://api.findyournextapartment.com') { return }
        root.$store.commit('auth/STORE_TOKEN', event.data)
        dialog.value = false
      })
    })
    watch(dialog, () => {
      isSigningIn.value = true
      emailErrors.value = ''
      passwordErrors.value = ''
    })
    watch(isSigningIn, () => {
      emailErrors.value = ''
      passwordErrors.value = ''
    })
    watch([() => form.email, () => form.password], () => {
      emailErrors.value = ''
      passwordErrors.value = ''
    })

    const login = async () => {
      if (formRef.value === null) { return }
      formRef.value.validate()
      if (!isValid.value) { return }
      try {
        await root.$store.dispatch('auth/signIn', form)

        dialog.value = false
      } catch (error) {
        if (error.response.status > 400 && error.response.status <= 500) {
          emailErrors.value = ''
          passwordErrors.value = 'The credentials are not correct'
        } else {
          passwordErrors.value = 'Connection error'
        }
      }
    }
    const register = async () => {
      if (formRef.value === null) { return }
      formRef.value.validate()
      if (!isValid.value) { return }
      try {
        await root.$store.dispatch('auth/signUp', form)
        dialog.value = false
      } catch (error) {
        if (error.response.status === 409) {
          emailErrors.value = 'Email is already taken'
          passwordErrors.value = ''
        } else {
          passwordErrors.value = 'Use a stronger password'
        }
      }
    }
    const actionBtn = () => {
      if (isLoggedIn.value) {
        root.$store.commit('auth/LOGOUT')
      } else {
        dialog.value = !dialog.value
      }
    }

    return {
      dialog,
      isValid,
      formRef,
      isLoading,
      form,
      emailErrors,
      mdiClose,
      openPopUp (name: string) {
        window.open('https://api.findyournextapartment.com/auth/thirdparty/' + name.toLowerCase(), 'Authentication', 'width=400,height=600')
      },
      passwordErrors,
      isSigningIn,
      isLoggedIn,
      asFullScreen: computed(() => root.$vuetify?.breakpoint?.smAndDown ?? false),
      // Functions
      login,
      register,
      actionBtn,
      // Constants
      emailRules: [
        (v: string) => !!v || 'E-mail is required',
        (v: string) => /.+@.+\..+/.test(v) || 'E-mail must be valid'
      ],
      socials: [
        { name: 'Facebook', color: colors.indigo.base, icon: mdiFacebook, iconSize: 24 },
        { name: 'Google', color: colors.red.base, icon: mdiGoogle, iconSize: 20 }
      ]
    }
  }
})
</script>
